HackerBase Modules
==================

This file contains documentation of all exported symbols of all
modules used. Modules are grouped according to their specificity to
this project.

Functional Modules
------------------

These modules are specific to this project and their generic usage is
questionable.

### Members Fees Computation

### Members Payments Processor

### Members Info Printer

Export Modules
--------------

These modules generate export files for other systems.

### Cards

    (import cards)

Exports files with card information for BrmDoor.

    (cards-export mb cards desfire)

* ```mb``` - mbase structure
* ```cards``` - file path for generic cards
* ```desfire``` - file path for desfire cards

Generates two files with cards information for all active members. The
file format is compatible with BrmDoor project.

### Web Static

    (import web-static)

This module implements JendaSAP-compatible DokuWiki static files export.

    (gen-web-static-member mr [dir])

* ```mr``` - member structure
* ```dir``` - optional output directory

For given member ```mr``` Generates the following files in given
directory ```dir``` which defaults to current directory:

* nick.id - contains member id
* nick.balance - total current balance
* nick.misc - whole member file
* nick.log - git log of the member file

All four files use members' nick as base name.

    (gen-web-static mb dir)

* ```mb``` - mbase instance
* ```dir``` - path to destination directory

Generates static web files for all members in given mbase ```mb``` and
stores them in the destination directory ```dir```.
