;;
;; gendoc.scm
;;
;; Generate documentation for all documented modules dynamically.
;;
;; ISC License
;;
;; Copyright 2023 Brmlab, z.s.
;; Dominik Pantůček <dominik.pantucek@trustica.cz>
;;
;; Permission to use, copy, modify, and/or distribute this software
;; for any purpose with or without fee is hereby granted, provided
;; that the above copyright notice and this permission notice appear
;; in all copies.
;; 
;; THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
;; WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
;; WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
;; AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR
;; CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
;; OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
;; NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
;; CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
;;

(import duck-extract)

(define-syntax gen-duck
  (syntax-rules ()
    ((_ fname title abstract mod ...)
     (begin
       (import mod ...)
       (with-output-to-file fname
	 (lambda ()
	   (print "# " title)
	   (newline)
	   (print abstract)
	   (let ()
	     (newline)
	     (print-module-duck mod))
	   ...
	   ))))))

(gen-duck "doc/d-utils.md"
	  "Utility modules"
	  "These are various utility modules for other HackerBase libraries."
	  util-time
	  util-csv
	  util-git
	  util-io
	  util-stdout
	  util-parser
	  util-proc
	  util-format
	  util-tag
	  util-string
	  util-mail
	  util-bst
	  util-bst-bdict
	  util-bst-ldict
	  util-bst-lset
	  util-dir
	  util-utf8
	  )
