;;
;; mailman-common.scm
;;
;; Mailman management interface - Common Functions
;;
;; ISC License
;;
;; Copyright 2023 Brmlab, z.s.
;; Dominik Pantůček <dominik.pantucek@trustica.cz>
;;
;; Permission to use, copy, modify, and/or distribute this software
;; for any purpose with or without fee is hereby granted, provided
;; that the above copyright notice and this permission notice appear
;; in all copies.
;; 
;; THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
;; WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
;; WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
;; AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR
;; CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
;; OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
;; NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
;; CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
;;

(declare (unit mailman-common))

(module
 mailman-common
 (
  make-mailman-list

  mailman-list-name
  mailman-list-members
  
  email-in-mailman-list?
  )

 (import scheme
	 util-bst-lset)

 ;; Creates a representation of basic mailman list information
 (define (make-mailman-list name members)
   (cons name
	 members))

 ;; Simple accessors
 (define mailman-list-name car)
 (define mailman-list-members cdr)

 ;; Returns #t if the email is in given ml
 (define (email-in-mailman-list? ml email)
   (if (lset-member? (list->lset (mailman-list-members ml) string-ci=?)
		     email)
       #t
       #f))

 )
